package com.sun.xml.internal.ws.wsdl.parser;

import javax.xml.stream.XMLStreamException;
import org.xml.sax.SAXException;
import java.io.IOException;
import java.util.Iterator;
import javax.xml.transform.Transformer;
import com.sun.xml.internal.ws.util.JAXWSUtils;
import javax.xml.transform.TransformerException;
import javax.xml.ws.WebServiceException;
import com.sun.xml.internal.stream.buffer.XMLStreamBufferResult;
import com.sun.xml.internal.ws.util.xml.XmlUtil;
import java.util.HashMap;
import javax.xml.transform.Source;
import java.util.List;
import com.sun.xml.internal.ws.api.server.SDDocumentSource;
import java.util.Map;
import com.sun.xml.internal.ws.api.wsdl.parser.XMLEntityResolver;

public final class MexEntityResolver implements XMLEntityResolver
{
    private final Map<String, SDDocumentSource> wsdls;
    
    public MexEntityResolver(List<? extends Source> wsdls) throws IOException {
        this.wsdls = new HashMap();
        Transformer transformer = XmlUtil.newTransformer();
        for (Source source : wsdls) {
            XMLStreamBufferResult xsbr = new XMLStreamBufferResult();
            try {
                transformer.transform(source, xsbr);
            }
            catch (TransformerException e) {
                throw new WebServiceException(e);
            }
            String systemId = source.getSystemId();
            if (systemId != null) {
                SDDocumentSource doc = SDDocumentSource.create(JAXWSUtils.getFileOrURL(systemId), xsbr.getXMLStreamBuffer());
                this.wsdls.put(systemId, doc);
            }
            else {
                continue;
            }
        }
    }
    
    public XMLEntityResolver.Parser resolveEntity(String publicId, String systemId) throws SAXException, IOException, XMLStreamException {
        if (systemId != null) {
            SDDocumentSource src = (SDDocumentSource)this.wsdls.get(systemId);
            if (src != null) {
                return new XMLEntityResolver.Parser(src);
            }
        }
        return null;
    }
}
